import { ConfigurableModuleBuilder, Inject, Module } from '@nestjs/common';
import { Aragami, AragamiOptions } from 'aragami';

const { ConfigurableModuleClass, MODULE_OPTIONS_TOKEN } =
  new ConfigurableModuleBuilder<AragamiOptions>()
    .setExtras(
      {
        isGlobal: true,
      },
      (definition, extras) => ({
        ...definition,
        global: extras.isGlobal,
      }),
    )
    .build();

export const ARAGAMI_TOKEN = 'ARAGAMI_TOKEN';
export const InjectAragami = () => Inject(ARAGAMI_TOKEN);

@Module({
  providers: [
    {
      provide: ARAGAMI_TOKEN,
      useFactory: (options: AragamiOptions) => new Aragami(options),
      inject: [MODULE_OPTIONS_TOKEN],
    },
  ],
  exports: [ARAGAMI_TOKEN],
})
export class AragamiModule extends ConfigurableModuleClass {}

export * from './src/aragami-cache.interceptor';
export * from './src/queue-runner';
